/* VCp */
#define _CRT_SECURE_NO_DEPRECATE

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <windows.h>

/*
	ʓ|ȂŃG[`FbN͏ȗĂ܂B
	ςȂƂ炽Ԃ񗎂̂ŒӁB
*/

typedef struct bitmap_struct
{
	int w, h;
	int align;
	char *dib;
} bitmap_t;

bitmap_t * load_bitmap(char *file)
{
	FILE *fp;
	BITMAPFILEHEADER bhead;
	BITMAPINFOHEADER binfo;
	BITMAPCOREHEADER bcore;
	DWORD size, w, h;
	bitmap_t *bmp;
	
	/* rbg}bv[h */
	fp = fopen(file, "rb");
	if (fp == NULL) return NULL;
	
	fseek(fp, 0, SEEK_SET);
	fread(&bhead, sizeof(BITMAPFILEHEADER), 1, fp);
	if (bhead.bfType != 0x4d42)
	{
		/* rbg}bvt@Cł͂Ȃ */
		fclose(fp);
		return NULL;
	}

	fread(&size, sizeof(DWORD), 1, fp);
	fseek(fp, sizeof(BITMAPFILEHEADER), SEEK_SET);

	if (size == sizeof(BITMAPCOREHEADER))
	{
		/* v̉摜t@Č` */
		fread(&bcore, sizeof(BITMAPCOREHEADER), 1, fp);
		if (bcore.bcBitCount != 24)
		{
			/* 24bitɂ̂ݑΉ */
			fclose(fp);
			return NULL;
		}

		w = bcore.bcWidth;
		h = bcore.bcHeight;
	}
	else
	{
		/* ʂ̃rbg}bv` */
		fread(&binfo, sizeof(BITMAPINFOHEADER), 1, fp);
		if (binfo.biBitCount != 24)
		{
			/* 24bitɂ̂ݑΉ */
			fclose(fp);
			return NULL;
		}

		w = binfo.biWidth;
		h = binfo.biHeight;
	}
	
	/* rbg}bv̍쐬 */
	bmp = malloc(sizeof(bitmap_t));
	bmp->w = w;
	bmp->h = h;
	bmp->align = (bmp->w * 24 / 8 + 3) & ~3;
	bmp->dib = malloc(bmp->align * bmp->h);
	
	/* [h */
	fread(bmp->dib, bmp->align * bmp->h, 1, fp);
	
	fclose(fp);
	
	return bmp;
}

void save_bitmap(char *file, bitmap_t *bmp)
{
	FILE *fp;
	BITMAPFILEHEADER bhead =
	{
		0x4d42,
		sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + bmp->align * bmp->h,
		0, 0,
		sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER),
	};
	BITMAPINFOHEADER binfo =
	{
		sizeof(BITMAPINFOHEADER),
		bmp->w,
		bmp->h,
		1,
		24,
		BI_RGB,
		bmp->align * bmp->h,
	};
	
	/* rbg}bvt@Cɕۑ */
	fp = fopen(file, "wb");
	if (fp == NULL) return;
	
	fseek(fp, 0, SEEK_SET);
	fwrite(&bhead, sizeof(BITMAPFILEHEADER), 1, fp);
	fwrite(&binfo, sizeof(BITMAPINFOHEADER), 1, fp);
	fwrite(bmp->dib, bmp->align * bmp->h, 1, fp);
	
	fclose(fp);
}

void release_bitmap(bitmap_t *bmp)
{
	/* rbg}bv */
	if (bmp != NULL)
	{
		if (bmp->dib != NULL)
		{
			free(bmp->dib);
		}
		free(bmp);
	}
}

#define get_dib(bmp, x, y, offset) (bmp)->dib[(bmp)->align * ((bmp)->h - 1 - (y)) + (x) * 3 + (offset)]
#define make_rgb(r, g, b) (((r) & 0xff) << 16 | ((g) & 0xff) << 8 | ((b) & 0xff))

void blend_bitmap(bitmap_t *bmpD, int dx, int dy, int w, int h, bitmap_t *bmpS, int sx, int sy, int /* ߐF */tcol)
{
	int x, y;

	if (dx < 0 || dy < 0 || w <= 0 || h <= 0 || sx < 0 || sy < 0) return; /* W̐ */
	if (dx + w > bmpD->w || dy + h > bmpD->h || sx + w > bmpS->w || sy + h > bmpS->h) return; /* ͂ݏoAEg */

	for (y = 0; y < h; y++)
	{
		for (x = 0; x < w; x++)
		{
			if (get_dib(bmpS, sx+x, sy+y, 0) != ((char *)&tcol)[0] ||
				get_dib(bmpS, sx+x, sy+y, 1) != ((char *)&tcol)[1] ||
				get_dib(bmpS, sx+x, sy+y, 2) != ((char *)&tcol)[2])
			{
				/* ߐFł͂Ȃ cc ] */
				get_dib(bmpD, dx+x, dy+y, 0) = get_dib(bmpS, sx+x, sy+y, 0);
				get_dib(bmpD, dx+x, dy+y, 1) = get_dib(bmpS, sx+x, sy+y, 1);
				get_dib(bmpD, dx+x, dy+y, 2) = get_dib(bmpS, sx+x, sy+y, 2);
			}
		}
	}
}

char * strtok2(char *s, const char *d)
{
	char *r = strtok(s, d);

	if (r == NULL)
	{
		fprintf(stderr, "Xǧ`قȂ܂B\n");
		exit(1);
	}
	else return r;
}

void interpreter(void)
{
	char buf[1024];
	char *delim = ", \t\n";
	char *fileR, *fileD, *fileS;
	int dx, dy;
	int tr, tg, tb;
	bitmap_t *bmpD, *bmpS;

	while (fgets(buf, sizeof(buf), stdin) != NULL)
	{
		/* XgeIvV̎擾 */
		fileR = strtok2(buf, delim);
		fileD = strtok2(NULL, delim);
		dx = atoi(strtok2(NULL, delim));
		dy = atoi(strtok2(NULL, delim));
		fileS = strtok2(NULL, delim);
		tr = atoi(strtok2(NULL, delim));
		tg = atoi(strtok2(NULL, delim));
		tb = atoi(strtok2(NULL, delim));

		/* [h */
		bmpD = load_bitmap(fileD);
		if (bmpD == NULL)
		{
			fprintf(stderr, "%s̃I[vɎs܂B\n", fileD);
			exit(1);
		}
		bmpS = load_bitmap(fileS);
		if (bmpS == NULL)
		{
			release_bitmap(bmpD);
			fprintf(stderr, "%s̃I[vɎs܂B\n", fileD);
			exit(1);
		}
		
		/* pb`𓖂Ăĕۑ */
		blend_bitmap(bmpD, dx, dy, bmpS->w, bmpS->h, bmpS, 0, 0, make_rgb(tr, tg, tb));
		save_bitmap(fileR, bmpD);
		
		/*  */
		release_bitmap(bmpD);
		release_bitmap(bmpS);
	}
}

int main(int argc, const char **argv)
{
	freopen("patchlist.txt", "r", stdin);
	interpreter();

	return 0;
}
